# Sandbox MIP Trend Crawler module

python으로 google, naver의 trend 검색결과를 crawling하기 위한 프로젝트 입니다.


## Config

- 필요한 파일
  - naver search api 통신을 위한 json 혹은 sh 파일

필요한 파일들을 담당자 혹은 팀리드에게 받아 아래 위치에 저장합니다.

```bash
src/trends_crawler/.secrets/crawler_secrets.json
```

crawler_secrets.json 샘플

```json
{
  "NAVER_API_KEY": "abc",
  "NAVER_SECRET_KEY": "abc",
  "NAVER_CUSTOMER_ID": 111
}
```


## How to run

### Naver Ad Search

```bash
python main.py --type="a" --key="도티" --out="./result/out2.json"
```

#### 필수 
- type: j
- key: 검색 keyword
- out: 결과를 저장할 json 파일 경로


### Naver Trend

```bash
python main.py --type="j" --key="도티" --out="./result/out2.json" --period="date" --start="2022-01-15" --end="2022-03-21"
```

#### 필수 
- type: j
- key: 검색 keyword
- out: 결과를 저장할 json 파일 경로
- start: 기간 시작일 (period 옵션이 주간 혹은 월간인 경우, 일을 제외한 월 단위로 검색 함)
- end: 기간 종료일 (period 옵션이 주간 혹은 월간인 경우, 일을 제외한 월 단위로 검색 함)

#### 옵션 
- period: 기간 검색 타입 (기본 값은 date)
  - 일간: date
  - 주간: week
  - 월간: month
- gender: 성별
  - 남성: m
  - 여성: f
- age: 나이 (여러 개의 값을 요청할 경우 `,`로 구분)
  - 1: ~12
  - 2: 13~18
  - 3: 19~24
  - 4: 25~29
  - 5: 30~34
  - 6: 35~39
  - 7: 40~44
  - 8: 45~49
  - 9: 50~54
  - 10: 55~60
  - 11: 60~


### Naver Total Search

```bash
python main.py --type="n" --key="도티" --out="./result/out2.json" --start="2020-02-20" --end="2022-03-20"
```

#### 필수
- type: n
- key: keyword
- out: 결과를 저장할 json 파일 경로
- start: 검색 기간 시작일
- end: 검색 기간 종료일 

네이버 통합 검색, 첫 페이지(15개 항목) 결과의 제목과 링크를 조회합니다.

### Google Trend

```bash
python main.py --type="t" --key="도티" --out="./result/out.json"
```

#### 필수
- type: t
- key: keyword
- out: 결과를 저장할 json 파일 경로

#### 옵션 

- time: time -> '12-m', '1-H', '1-m', '12-d'
  - 각 조회 시점을 조절
  - 12-m : 현재 시점부터 12개월 전
  - 1-H: 현재 시간으로 부터 1시간 전
  - 1-d: 현재 시점으로 부터 1일전
- ncode: 국가 코드
- tz: timezone, 단 분(min)으로 사용해야 되면 한국는 -540
- gcode: 위치 코드 한국 "KR"


현재 날짜로 부터 12개월 내의 topic, query, timeseries
  - topic: 관련 주제
  - query: 관련 검색어 
  - timeseries: 시간 흐름에 따른 관심도 그래프 값


### Google Total Search

```bash
python main.py --type="g" --key="도티" --start="2022-04-01" --end="2022-04-17" --out="./result/out2.json"
```

#### 필수
- type: g
- key: keyword
- out: 결과를 저장할 json 파일 경로
- start: 검색 기간 시작일
- end: 검색 기간 종료일 

구글 통합 검색, 첫 페이지(10개 내외) 결과의 제목과 링크를 조회합니다.
